/*ghassan fakher
 * gkf01
 section 6s*/

public class CardDeck {
	private Card[] cards;        // array that holds the 52 cards
	private int top; 
	public CardDeck()
	{
		String[] ranks = {"2", "3", "4",  "5", "6", "7", "8", "9", "10", "J", "Q", "K", "A"};
		String[] suits = {"Clubs", "Diamonds", "Hearts", "Spades"};
		cards = new Card[52];
		for(int i = 0; i < ranks.length; i++)
		{
			for(int j = 0; j < suits.length; j++)
			{
				cards[i * 4 + j] = new Card(ranks[i], suits[j]);
			}
		}
		top = 0;
	}	
	public boolean isEmpty()
	{
		boolean empty = false;
		if(top == 52)
			empty = true;
		return empty;
	}
	public int cardsLeft()
	{
		int leftCards = 0;
		leftCards = 52 - top;
		return leftCards;
	}
	public Card draw()
	{
		Card drawn = cards[top];
		top++;
		return drawn;
	}
	public void shuffle()
	{
		for(int i = top; i < cards.length; i++)
		{
			int random = (int)(Math.random() * (cards.length - i) + i);
			Card temp = cards[i];
			cards[i] = cards[random];
			cards[random] = temp;
		}
	}
	public void sort()
	{
		for(int j = 1; j < cards.length; j++)
		{
			if(cards[j].rank().equals(cards[j - 1].rank()))
			{
				
				Card dummy = cards[j];
				int i = j - 1;
				while(i >= 0 && cards[i].stronger(dummy))
				{
					cards[i+1]=cards[i];
					cards[i]=dummy;
					i--;
				}
			}			
			else
			{
				Card dummy = cards[j];
				int i = j - 1;
				while(i >= 0 && cards[i].stronger(dummy))
				{
					cards[i+1]=cards[i];
					cards[i]=dummy;
					i--;
				}
			}		
		}
	}
}
